#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <stdbool.h>
#include <string.h>

float koordinaten[64][1024][3]; // 64 Molekle, 1024 Atome, 3 Raumdimensionen (xyz)
char atomtype[64][1024][4]; // 64 Molekle, 1024 Atome, 4-stelliges Label
char name[64][256]; // 64 Molekle, 256-stelliger Name
float abstand[64][512]; // 64 Molekle, 512 Abstnde
float absmittel[2][512]; // 0 = DistR 1 = DistM, 512 Abstnde
int population[64]; // 64 Molekuele
int populationshelfer[64]; // 64 Molekuele
int minpop[2][64]; // 0 = RMSD 1 = Q-Cornilescu, 64 Molekle
/* int populationsschleife[4]; // wegens der Symmetrie */
int i,j,k,l,r,q,anzahl_normale_abstaende,anzahl_symmetrische_abstaende,anzahl_methylabstaende,anzahl_symmetrische_methylabstaende;
float rmsd,qcornilescu,minqcornilescu,minrmsd,singlermsd[64]; // 64 Molekuele
int atom[256][2]; // 256 Abstnde zwischen 2 Atomen
int symm[0][4]; // 0 symmetrischer Abstand zwischen insgesamt 4 Atomen
int methyl[256][4]; // 256 Methylgruppenabstand mit insgesamt 4 Atomen
int symmmethyl[0][8]; // 0 symmetrischer Methylgruppenabstand zwischen insgesamt 8 Atomen
FILE *output;
bool check,methylgruppen;
int populationsteps,populationstepsize,anzahl_konformere;
char xyzinput[64][256];  // 64 Molekuele, 256 Zeichen
int length[64];  // 64 Molekuele
char atoinput[256]; // 256 Zeichen
char methylinput[256]; // 256 Zeichen
char hilfe[4][4];
char helpflag[2];
char methylflag[2];
char outputname[256]; // 256 Zeichen
char systembefehl[256]; //256 Zeichen

void koords() // funktioniert
{
   /* printf("DEBUG: koords start\n"); */
   
   FILE *kor;
   l = 0;
   
   for(j = 0; j < anzahl_konformere;j++) {
      kor = fopen(xyzinput[j], "r");
      if(NULL == kor) {
         fprintf(stderr, "Error while opening the xyzfile %i: %s.\n",j+1,xyzinput[j]);
      }
   
      fscanf(kor, "%d\n", &length[j]);
      
      if(length[j] != length[0]) {
         fprintf(stderr, "Error. Different numbers of atoms.\n");
      }
      
      fscanf(kor,"%[^\n]%*c",&name[j]);
      // printf("Lnge: %d - Label: %s\n",length[j],name[j]);
    
       while((fscanf(kor,"%c%c%c%c %f %f %f\n",&atomtype[j][l][0],&atomtype[j][l][1],&atomtype[j][l][2],&atomtype[j][l][3],&koordinaten[j][l][0],&koordinaten[j][l][1],&koordinaten[j][l][2])) != EOF ) {
          // printf("%c%c%c%c %f %f %f\n",atomtype[j][l][0],atomtype[j][l][1],atomtype[j][l][2],atomtype[j][l][3],koordinaten[j][l][0],koordinaten[j][l][1],koordinaten[j][l][2]);
          l++;
      }
   
      fclose(kor);
      l = 0;
   }
   
   
   anzahl_normale_abstaende = 0;
   kor = fopen(atoinput, "r");
   if(NULL == kor) {
      fprintf(stderr, "Error while opening the distance file: %s.\n",atoinput);
   }

   while((fscanf(kor,"%c%c%c%c %c%c%c%c %f\n",&hilfe[0][0],&hilfe[0][1],&hilfe[0][2],&hilfe[0][3],&hilfe[1][0],&hilfe[1][1],&hilfe[1][2],&hilfe[1][3],&absmittel[0][l])) != EOF ) {
       for(j = 0; j < length[0];j++) {
             if((atomtype[0][j][0] == hilfe[0][0]) && (atomtype[0][j][1] == hilfe[0][1]) && (atomtype[0][j][2] == hilfe[0][2]) && (atomtype[0][j][3] == hilfe[0][3])){
                   atom[l][0] = j;
             }
             if((atomtype[0][j][0] == hilfe[1][0]) && (atomtype[0][j][1] == hilfe[1][1]) && (atomtype[0][j][2] == hilfe[1][2]) && (atomtype[0][j][3] == hilfe[1][3])){
                   atom[l][1] = j;
             }
       }
       l++;
   } 
   fclose(kor);
   anzahl_normale_abstaende = l; 
   l=0; 
   
   
   anzahl_symmetrische_abstaende = 0;
   /* kor = fopen("symm.ato", "r");
   if(NULL == kor) {
      fprintf(stderr, "Error while opening symm.ato\n");
   }

   while((fscanf(kor,"%d|%d|%d|%d|%f\n",&symm[l][0],&symm[l][1],&symm[l][2],&symm[l][3],&absmittel[0][anzahl_normale_abstaende+l])) != EOF ) {
       l++;
   }
   fclose(kor); 
   anzahl_symmetrische_abstaende = l; 
   l = 0;
   */
   anzahl_methylabstaende = 0;
   
   if (methylgruppen) { kor = fopen(methylinput, "r");
      if(NULL == kor) {
         fprintf(stderr, "Error while opening the methyl distance file: %s.\n",methylinput);
      }
   
      while((fscanf(kor,"%c%c%c%c %c%c%c%c %c%c%c%c %c%c%c%c %f\n",&hilfe[0][0],&hilfe[0][1],&hilfe[0][2],&hilfe[0][3],&hilfe[1][0],&hilfe[1][1],&hilfe[1][2],&hilfe[1][3],&hilfe[2][0],&hilfe[2][1],&hilfe[2][2],&hilfe[2][3],&hilfe[3][0],&hilfe[3][1],&hilfe[3][2],&hilfe[3][3],&absmittel[0][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+l])) != EOF ) {
          for(j = 0; j < length[0];j++) {
                if((atomtype[0][j][0] == hilfe[0][0]) && (atomtype[0][j][1] == hilfe[0][1]) && (atomtype[0][j][2] == hilfe[0][2]) && (atomtype[0][j][3] == hilfe[0][3])){
                      methyl[l][0] = j;
                }
                if((atomtype[0][j][0] == hilfe[1][0]) && (atomtype[0][j][1] == hilfe[1][1]) && (atomtype[0][j][2] == hilfe[1][2]) && (atomtype[0][j][3] == hilfe[1][3])){
                      methyl[l][1] = j;
                }
                if((atomtype[0][j][0] == hilfe[2][0]) && (atomtype[0][j][1] == hilfe[2][1]) && (atomtype[0][j][2] == hilfe[2][2]) && (atomtype[0][j][3] == hilfe[2][3])){
                      methyl[l][2] = j;
                }
                if((atomtype[0][j][0] == hilfe[3][0]) && (atomtype[0][j][1] == hilfe[3][1]) && (atomtype[0][j][2] == hilfe[3][2]) && (atomtype[0][j][3] == hilfe[3][3])){
                      methyl[l][3] = j;
                }
          }
          l++;
      } 
      fclose(kor);
      anzahl_methylabstaende = l; 
      l = 0; 
   }
   /* 
   while((fscanf(kor,"%d|%d|%d|%d|%f\n",&methyl[l][0],&methyl[l][1],&methyl[l][2],&methyl[l][3],&absmittel[0][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+l])) != EOF ) {
       l++;
   }
  */
   
   anzahl_symmetrische_methylabstaende = 0;
   /* kor = fopen("symmmethyl.ato", "r");
   if(NULL == kor) {
      fprintf(stderr, "Error while opening symmmethyl.ato\n");
   }

   while((fscanf(kor,"%d|%d|%d|%d|%d|%d|%d|%d|%f\n",&symmmethyl[l][0],&symmmethyl[l][1],&symmmethyl[l][2],&symmmethyl[l][3],&symmmethyl[l][4],&symmmethyl[l][5],&symmmethyl[l][6],&symmmethyl[l][7],&absmittel[0][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l])) != EOF ) {
       l++;
   }
   fclose(kor);
   anzahl_symmetrische_methylabstaende = l;
   l = 0; */
   /*
   kor = fopen("name.nam", "r");
   if(NULL == kor) {
      fprintf(stderr, "Error while opening name.nam\n");
   }

   while((fscanf(kor,"%c%c%c%c%c%c%c%c%c%c%c%c\n",&name[l][0],&name[l][1],&name[l][2],&name[l][3],&name[l][4],&name[l][5],&name[l][6],&name[l][7],&name[l][8],&name[l][9],&name[l][10],&name[l][11])) != EOF ) {
       l++;
   }
   fclose(kor); */
   
   /* printf("DEBUG: koords ende\n"); */
}

float laenge(float vektor[3]) // funktioniert
{
   /* printf("DEBUG: laenge start\n"); */
   float ergebnis;
   ergebnis = sqrt(vektor[0]*vektor[0] + vektor[1]*vektor[1] + vektor[2]*vektor[2]);
   /* printf("DEBUG: laenge ende\n"); */
   return(ergebnis);
}

void abstaende(int mol) // funktioniert
{
     /* printf("DEBUG: abstaende start\n"); */
     float vektor[3];
     int len = anzahl_normale_abstaende;
     for (j=0;j<len;j++){
       for(i=0;i<3;i++){
         vektor[i] = koordinaten[mol][atom[j][0]][i] - koordinaten[mol][atom[j][1]][i];
       }
       abstand[mol][j] = laenge(vektor);
     }
     /* printf("DEBUG: abstaende ende\n"); */
}

void symmetrischeabstaende(int mol) // funktioniert
{
     /* printf("DEBUG: symmetrischeabstaende start\n"); */
     float vektor[2][3];
     int len = anzahl_symmetrische_abstaende;
     for (j=0;j<len;j++){
       for(i=0;i<3;i++){
         vektor[0][i] = koordinaten[mol][symm[j][0]][i] - koordinaten[mol][symm[j][1]][i];
         vektor[1][i] = koordinaten[mol][symm[j][2]][i] - koordinaten[mol][symm[j][3]][i];
       }
       abstand[mol][anzahl_normale_abstaende+j] = pow( 0.5*( pow(laenge(vektor[0]),(-6)) + pow(laenge(vektor[1]),(-6)) ),(-1.0/6.0));
     }
     /* printf("DEBUG: symmetrischeabstaende ende\n"); */
}

void methylabstaende(int mol) // funktioniert
{
     /* printf("DEBUG: methylabstaende start\n"); */
     float vektor[3][3];
     int len = anzahl_methylabstaende;
     for (j=0;j<len;j++){
       for(i=0;i<3;i++){
         vektor[0][i] = koordinaten[mol][methyl[j][0]][i] - koordinaten[mol][methyl[j][1]][i];
         vektor[1][i] = koordinaten[mol][methyl[j][0]][i] - koordinaten[mol][methyl[j][2]][i];
         vektor[2][i] = koordinaten[mol][methyl[j][0]][i] - koordinaten[mol][methyl[j][3]][i];
       }
       abstand[mol][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+j] = pow( (1.0/3.0) *( pow(laenge(vektor[0]),(-3)) + pow(laenge(vektor[1]),(-3)) + pow(laenge(vektor[2]),(-3)) ),(-1.0/3.0));
     }
     /* printf("DEBUG: methylabstaende ende\n"); */
}

void symmetrischemethylabstaende(int mol) // scheint zu funktionieren
{
     /* printf("DEBUG: symmetrischemethylabstaende start\n"); */
     float vektor[6][3],methylabstand[2];
     int len = anzahl_symmetrische_methylabstaende;
     for (j=0;j<len;j++){
       for(i=0;i<3;i++){
         vektor[0][i] = koordinaten[mol][symmmethyl[j][0]][i] - koordinaten[mol][symmmethyl[j][1]][i];
         vektor[1][i] = koordinaten[mol][symmmethyl[j][0]][i] - koordinaten[mol][symmmethyl[j][2]][i];
         vektor[2][i] = koordinaten[mol][symmmethyl[j][0]][i] - koordinaten[mol][symmmethyl[j][3]][i];
         vektor[3][i] = koordinaten[mol][symmmethyl[j][4]][i] - koordinaten[mol][symmmethyl[j][5]][i];
         vektor[4][i] = koordinaten[mol][symmmethyl[j][4]][i] - koordinaten[mol][symmmethyl[j][6]][i];
         vektor[5][i] = koordinaten[mol][symmmethyl[j][4]][i] - koordinaten[mol][symmmethyl[j][7]][i];
         
       }
       methylabstand[0] = pow( (1.0/3.0) *( pow(laenge(vektor[0]),(-3)) + pow(laenge(vektor[1]),(-3)) + pow(laenge(vektor[2]),(-3)) ),(-1.0/3.0));
       methylabstand[1] = pow( (1.0/3.0) *( pow(laenge(vektor[3]),(-3)) + pow(laenge(vektor[4]),(-3)) + pow(laenge(vektor[5]),(-3)) ),(-1.0/3.0));
       abstand[mol][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+j] = pow( 0.5*( pow(methylabstand[0],(-6)) + pow(methylabstand[1],(-6)) ),(-1.0/6.0));
     }
     /* printf("DEBUG: symmetrischemethylabstaende ende\n"); */
}

void abstandsmittelung(int anzmol) // funktioniert
{
     /* printf("DEBUG: abstandsmittelung start\n"); */
     int len = anzahl_normale_abstaende + anzahl_symmetrische_abstaende + anzahl_methylabstaende + anzahl_symmetrische_methylabstaende;
     for (i=0;i<len;i++){
       absmittel[1][i] = 0;
       for (j=0;j<anzmol;j++){
         absmittel[1][i] = absmittel[1][i] + (population[j]/100.0)*pow(abstand[j][i],(-6));
       }
       absmittel[1][i] = pow(absmittel[1][i],(-1.0/6.0));
     }
     /* printf("DEBUG: abstandsmittelung ende\n"); */
}

void qualitaet() // funktioniert
{
      /* printf("DEBUG: qualitaet start\n"); */
      rmsd = 0.0;
      qcornilescu = 0.0;
      int len = anzahl_normale_abstaende + anzahl_symmetrische_abstaende + anzahl_methylabstaende + anzahl_symmetrische_methylabstaende;
      for (q=0;q<len;q++){
         rmsd = rmsd + pow(absmittel[1][q]-absmittel[0][q],2);
         qcornilescu = qcornilescu + pow(absmittel[0][q],2);
      }
      rmsd = rmsd / len;
      rmsd = pow(rmsd,0.5);
      
      qcornilescu = qcornilescu / len;
      qcornilescu = pow(qcornilescu,0.5);
      
      qcornilescu = rmsd / qcornilescu;
      
      
      /* printf("DEBUG: qualitaet ende\n"); */
}

void ausgabe()
{ 
  /* printf("DEBUG: ausgabe start\n"); */
  fprintf(output,"=======================================================================================\n");
  fprintf(output,"populations ");
  for(i=0;i<anzahl_konformere;i++) {
     fprintf(output,"%4i%% ",population[i]);
}
  fprintf(output,"RMSD %.5f Q-Cornilescu %.5f\n",rmsd,qcornilescu);  
  fprintf(output,"Atom1 Atom2 ");
  for(i=0;i<anzahl_konformere;i++) {
    fprintf(output,"Dist%1i ",i+1);
  }
  fprintf(output,"DistM DistR\n"); 
  int len = anzahl_normale_abstaende;
  for (l=0;l<len;l++){
     fprintf(output,"%c%c%c%c  %c%c%c%c  ",atomtype[0][atom[l][0]][0],atomtype[0][atom[l][0]][1],atomtype[0][atom[l][0]][2],atomtype[0][atom[l][0]][3],atomtype[0][atom[l][1]][0],atomtype[0][atom[l][1]][1],atomtype[0][atom[l][1]][2],atomtype[0][atom[l][1]][3]);
     for(i=0;i<anzahl_konformere;i++) {
        fprintf(output,"%.3f ",abstand[i][l]);
     }
     fprintf(output,"%.3f %.3f\n",absmittel[1][l],absmittel[0][l]);
  }
  /* len = anzahl_symmetrische_abstaende;
  for (l=0;l<len;l++){
     fprintf(output,"%c%c%c%c  %c%c%c%c  %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",atomtype[0][symm[l][0]][0],atomtype[0][symm[l][0]][1],atomtype[0][symm[l][0]][2],atomtype[0][symm[l][0]][3],atomtype[0][symm[l][1]][0],atomtype[0][symm[l][1]][1],atomtype[0][symm[l][1]][2],atomtype[0][symm[l][1]][3],abstand[0][anzahl_normale_abstaende+l],abstand[1][anzahl_normale_abstaende+l],abstand[2][anzahl_normale_abstaende+l],abstand[3][anzahl_normale_abstaende+l],abstand[4][anzahl_normale_abstaende+l],abstand[5][anzahl_normale_abstaende+l],abstand[6][anzahl_normale_abstaende+l],abstand[7][anzahl_normale_abstaende+l],absmittel[1][anzahl_normale_abstaende+l],absmittel[0][anzahl_normale_abstaende+l]);
  } */
  len = anzahl_methylabstaende;
  for (l=0;l<len;l++){
     fprintf(output,"%c%c%c%c  %c%c%c%c  ",atomtype[0][methyl[l][0]][0],atomtype[0][methyl[l][0]][1],atomtype[0][methyl[l][0]][2],atomtype[0][methyl[l][0]][3],atomtype[0][methyl[l][1]][0],atomtype[0][methyl[l][1]][1],atomtype[0][methyl[l][1]][2],atomtype[0][methyl[l][1]][3]);
     for(i=0;i<anzahl_konformere;i++) {
        fprintf(output,"%.3f ",abstand[i][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+l]);
     }
     fprintf(output,"%.3f %.3f\n",absmittel[1][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+l],absmittel[0][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+l]);
  }
  /* len = anzahl_symmetrische_methylabstaende;
  for (l=0;l<len;l++){
     fprintf(output,"%c%c%c%c  %c%c%c%c  %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",atomtype[0][symmmethyl[l][0]][0],atomtype[0][symmmethyl[l][0]][1],atomtype[0][symmmethyl[l][0]][2],atomtype[0][symmmethyl[l][0]][3],atomtype[0][symmmethyl[l][1]][0],atomtype[0][symmmethyl[l][1]][1],atomtype[0][symmmethyl[l][1]][2],atomtype[0][symmmethyl[l][1]][3],abstand[0][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[1][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[2][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[3][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[4][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[5][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[6][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],abstand[7][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],absmittel[1][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l],absmittel[0][anzahl_normale_abstaende+anzahl_symmetrische_abstaende+anzahl_methylabstaende+l]);
  } */
  /* printf("DEBUG: ausgabe ende\n"); */
}

void multi_conformer_fit(int *p) {
     for (i = 0; i < anzahl_konformere; i++) {
       population[i] = p[i]*populationstepsize;
     }
     abstandsmittelung(anzahl_konformere); // dann die Abstnde mitteln
     qualitaet(); // dann den RMSD bestimmen und Q-Cornilescu und bald andere Sachen
            if(rmsd<minrmsd){
              minrmsd = rmsd;
              for (j = 0; j < anzahl_konformere; j++) {
                minpop[0][j] = population[j];
              }                
            }
            if(qcornilescu<minqcornilescu){
              minqcornilescu = qcornilescu;
              for (j = 0; j < anzahl_konformere; j++) {
                minpop[1][j] = population[j];
              }                
            }
            ausgabe(); // und dann die Ausgabe
}

int populationen(int *p, int m, const int N, int n) { // geklaut von Volker, funktioniert
   int ntotal = 0;
   if ( n == N ) {
      multi_conformer_fit(p);
      ntotal++;
   }
   else {
      p[m]++;
      ntotal += populationen(p, m, N, n + 1);
      p[m]--;
      if ( m < ( anzahl_konformere - 1) ) {
         ntotal += populationen(p, m + 1, N, n);
      }
   }
   return ntotal;
}

int main(int argc, char *argv[])
{
 /* printf("DEBUG: main start\n"); */
 printf("=======================================================================================\n");
 printf("|                       This is WEEDHEAD v0.9 by Andreas Kolmer                       |\n");
 printf("|  WEEDHEAD Examines Experimental Distance Heretics from Ensemble Averaged Distances  |\n");
 printf("|                                                                                     |\n");
 printf("|                    WEEDHEAD is distributed under CC BY-NC-SA 4.0                    |\n");
 printf("|               (see http://creativecommons.org/licenses/by-nc-sa/4.0/)               |\n");
 printf("|                                                                                     |\n");
 printf("|             please cite: A. Kolmer, L. J. Edwards, I. Kuprov, C. M. Thiele,         |\n");
 printf("|                          J. Magn. Reson., in preparation.                           |\n");
 printf("=======================================================================================\n");
 
    /* printf("argc: %d\n", argc);	
	for(i=0; i < argc; i++) {
		printf("argv[%d]: %s\n", i, argv[i]);
	} */

  helpflag[0] = '-';
  helpflag[1] = 'h';
  methylflag[0] = '-';
  methylflag[1] = 'm';
  methylgruppen = false;

  if(argc < 2) {
          fprintf(stderr,"Error. WEEDHEAD needs more arguments. Try weedhead -h for help.\n");
  } else if (strcmp(argv[1],helpflag) == 0) {
                printf("\ncommand line: weedhead (-m) coordinatefile1.xyz coordinatefile2.xyz (coordinatefile3.xyz ..) distancefile1.txt (distancefile2.txt)\n\n");
                printf("The coordinate files have to be xyz-files. You can use as many as you wish, but it may take longer to calculate all combinations.\n");
                printf("Structure of the xyz-file is as expected: Line 1 contains the number of atoms, line 2 a comment (that will be ignored).\n");
                printf("From line 3 there are the coordinates. First the label of the atom, then the x-, the y- and the z-coordinate.\n");
                printf("The label has to have four characters. Enter some spaces after the label if that is not the case.\n");
                printf("Also, make sure that the order of atoms is exactly the same in each xyz-file.\n\n");
                printf("The distance file can be anything, for example a txt-file. Use the same atom labels as in the xyz-file.\n");
                printf("Each line contains two atom labels and a distance.\n\n");
                printf("If methyl distances are included, add the flag -m, and enter the distance in distancefile2.\n");
                printf("The distancefile2 should be as follows: First the atom not in the methyl group, and then the three atoms in the methyl group.\n");
                printf("Last, again, the distance. Always use decimal points.\n\n");
    } else {
              
       if (strcmp(argv[1],methylflag) == 0) { // wenn Methylgruppen
                methylgruppen = true;
                anzahl_konformere = argc - 4;
                for(j = 0; j < anzahl_konformere;j++) {
                   for(i = 0; i < strlen(argv[j+2]); i++) { 
                      xyzinput[j][i] = argv[j+2][i]; 
                   }
                }
             
                for(i = 0; i < strlen(argv[j+2]); i++) { 
                      atoinput[i] = argv[argc-2][i]; 
                }
                
                for(i = 0; i < strlen(argv[j+3]); i++) { 
                      methylinput[i] = argv[argc-1][i]; 
                }
                
             } else { // wenn keine Methylgruppen
                anzahl_konformere = argc - 2;
                for(j = 0; j < anzahl_konformere;j++) {
                   for(i = 0; i < strlen(argv[j+1]); i++) { 
                      xyzinput[j][i] = argv[j+1][i]; 
                   }
                }
             
                for(i = 0; i < strlen(argv[j+1]); i++) { 
                      atoinput[i] = argv[argc-1][i]; 
                }
                
                
       }
       
	   
	   time_t current_time;
       char c_time_string[100];
	   current_time = time(NULL);
	   strftime(c_time_string,100,"%Y-%m-%d-%H-%M-%S",localtime(&current_time));
	   
	   strcat(outputname,"weedhead-output_");
	   strcat(outputname,c_time_string);
	   strcat(outputname,".noe");
       
       
       output=fopen(outputname,"w+");
       if(output != NULL) {
             fprintf(output,"=======================================================================================\n");
             fprintf(output,"|                       This is WEEDHEAD v0.9 by Andreas Kolmer                       |\n");
             fprintf(output,"|  WEEDHEAD Examines Experimental Distance Heretics from Ensemble Averaged Distances  |\n");
             fprintf(output,"|                                                                                     |\n");
             fprintf(output,"|                    WEEDHEAD is distributed under CC BY-NC-SA 4.0                    |\n");
             fprintf(output,"|               (see http://creativecommons.org/licenses/by-nc-sa/4.0/)               |\n");
             fprintf(output,"|                                                                                     |\n");
             fprintf(output,"|             please cite: A. Kolmer, L. J. Edwards, I. Kuprov, C. M. Thiele,         |\n");
             fprintf(output,"|                     J. Magn. Reson. 2015, in preparation.                           |\n");
             fprintf(output,"=======================================================================================\n");
             minrmsd = 999.999;  
             minqcornilescu = 999.999;
                 
             koords(); // erstmal Koordinaten laden
             for (l=0;l<anzahl_konformere;l++){ 
                abstaende(l);  // dann die normalen Abstnde in den Moleklen bestimmen
                symmetrischeabstaende(l); // dann die symmetrischen Abstnde in den Moleklen bestimmen mit r^6 (sinnvoll?)
                methylabstaende(l); // und dann die Methylgruppen mit r^3 mitteln
                symmetrischemethylabstaende(l); // und dann die symmetrischen Methylgruppen, r^6 und r^3 wie bei symmetrisch/methyl
              } 
  
              // anzahl_normale_abstaende = 0; warum ist das ntig??? Der zerschiet beim letzten Durchlauf anscheinend manchmal diese Variable
  
              // Single-Conformer-Fit
              printf("WEEDHEAD will use the following structures:\n");
              fprintf(output,"WEEDHEAD will use the following structures:\n");
              for (l=0;l<anzahl_konformere;l++){ 
                  rmsd = 0.0;
                  for (j=0;j<anzahl_konformere;j++){ 
                      population[j] = 0;
                  }
                  population[l] = 100;
                  abstandsmittelung(anzahl_konformere); 
                  qualitaet(); 
                  printf("%i: %s RMSD %.3f Q-Cornilescu %.3f\n",l+1,xyzinput[l],rmsd,qcornilescu);
                  fprintf(output,"%i: %s RMSD %.3f Q-Cornilescu %.3f\n",l+1,xyzinput[l],rmsd,qcornilescu);
              }
              printf("=======================================================================================\n");
              
              // es folgt der Multi-Conformer-Fit
              for ( i = 0; i < anzahl_konformere; i++ ) {
                populationshelfer[i] = 0;
              }
              if (anzahl_konformere <= 4) {
                 populationsteps = 100;
              } else if (anzahl_konformere == 5) {
                 populationsteps = 50;
              } else if (anzahl_konformere == 6) {
                 populationsteps = 25;
              } else if (anzahl_konformere == 7) {
                 populationsteps = 20;
              } else if (anzahl_konformere <= 12) {
                 populationsteps = 10;
              } else if (anzahl_konformere <= 33) {
                 populationsteps = 5;
              } else if (anzahl_konformere <= 57) {
                 populationsteps = 4;
              } else  {
                 populationsteps = 2;
              }
              populationstepsize = 100 / populationsteps;
              populationen(populationshelfer,0,populationsteps,0);
              
               
                  
              fprintf(output,"=======================================================================================\n\n"); 
              fprintf(output,"WEEDHEAD found lowest RMSD %.5f\n",minrmsd);
              for (l=0;l<anzahl_konformere;l++){ 
                  fprintf(output," %4i%% %s \n",minpop[0][l],xyzinput[l]);
              } 
              fprintf(output,"\nWEEDHEAD found lowest Q-Cornilescu %.5f\n",minqcornilescu);
              for (l=0;l<anzahl_konformere;l++){ 
                  fprintf(output," %4i%% %s \n",minpop[1][l],xyzinput[l]);
              } 
              fprintf(output,"\nGreat success.");
              printf("WEEDHEAD found lowest RMSD %.5f\n",minrmsd);
              for (l=0;l<anzahl_konformere;l++){ 
                  printf(" %4i%% %s \n",minpop[0][l],xyzinput[l]);
              } 
              printf("=======================================================================================\n");
              printf("WEEDHEAD found lowest Q-Cornilescu %.5f\n",minqcornilescu);
              for (l=0;l<anzahl_konformere;l++){ 
                  printf(" %4i%% %s \n",minpop[1][l],xyzinput[l]);
              } 
              fclose(output);
              
       } else {
              printf("Error while creating output file: %s\n",outputname);
       }
    } 
 
 strcat(systembefehl,"grep 'populations' ");
 strcat(systembefehl,outputname);
 strcat(systembefehl," > ");
 strcat(systembefehl,outputname);
 strcat(systembefehl,".pop");
 system(systembefehl);
 printf("=======================================================================================\n");
 printf("Great success.\n");
 printf("=======================================================================================\n");
 /* printf("DEBUG: main ende\n"); */
 return EXIT_SUCCESS;
}

/* Versionsgeschichte
v0.1 -> erste Version - luft! Kann vier Konformere, aber nicht rekursiv 
v0.2 -> hat Name und vergisst die Namen der Konformere nicht (12 Stellen) 
v0.3 -> Symmetrische Molekle bzw. Abstnde werden ordentlich berechnet
v0.4 -> Methylgruppen mit r^3 gemittelt 
v0.5 -> Symmetrische Methylgruppen gehen auch
v0.6 -> 8 Konformere, jetzt mit populationstepsize
v0.7 -> Populationen auf int umgestellt, wegen Rundungsfehlern
v0.7.1 -> extra fr das DMDAE-Projekt mit Symmetrie und so 
v0.8 -> extra fr das Strychnin-Projekt angepasst, kann jetzt auch Q-Cornilescu 
v0.8.1 -> extra fr das Lacton-Projekt angepasst
v0.9 -> Input mit xyz-Files und Textfiles ber die Kommandozeile, und rekursiv, und toller Output, yeah */
